(function ($) {
  const iFrame = window.frameElement;
  const inputElement = iFrame.parentElement.nextElementSibling;
  const totalElement = inputElement.nextElementSibling;
  let cardinality = iFrame.dataset['cardinality'] | 0;
  let values = {};
  let inputs = {};

  if (cardinality < 0) {
    cardinality = Infinity;
  }

  iFrame.parentElement.style.paddingTop = Math.max(window.document.body.parentElement.scrollHeight, window.document.body.scrollHeight) + 'px';

  window.addEventListener('DOMContentLoaded', function(e) {
    iFrame.parentElement.style.paddingTop = Math.max(window.document.body.parentElement.scrollHeight, window.document.body.scrollHeight) + 'px';
  });

  function updateTotal() {
    let count = Object.values(values).filter(Boolean).length;
    totalElement.innerHTML = `<em>${count} Selected</em>`;
  }

  function pullValues() {
    Object.keys(values).forEach(k => {
      values[k] = false;
    });

    inputElement.value.split(',').filter(Boolean).map(v => String(v).trim()).forEach(k => {
      values[k] = true;
    });

    Object.keys(values).forEach(k => {
      if (inputs[k]) {
        inputs[k].checked = Boolean(values[k]);
      }
    });

    updateTotal();
  }

  function setValue(id, v = true) {
    if (!id || !id.length) {
      debugger;
    }

    v = Boolean(v);

    if (values[id] != v) {
      if (v && Object.values(values).filter(Boolean).length >= cardinality) {
        if (cardinality !== 1) {
          inputs[id].checked = false;
          return;
        }

        values = {};

        Object.keys(inputs).forEach(k => {
          if (k != id) {
            inputs[k].checked = false;
          }
        });
      }

      values[id] = Boolean(v);

      inputElement.value = Object.keys(values).filter(v => values[v]).join(',') || '';
      updateTotal();
    }
  }

  Drupal.behaviors.viewInputViewEmbed = {
    attach: function (context) {
      once('view-input-view-embed', 'input.view-input-view-selector[type="checkbox"]', context).forEach(function (element) {
        let id = String(element.value);

        if (!id) {
          return;
        }

        inputs[id] = element;

        element.addEventListener('click', function (e) {
          if (id) {
            setValue(id, element.checked);
          }
        });
      });

      pullValues();
    },
  };
})(jQuery);
